import { __assign, __spread } from 'tslib';
import * as momentImported from 'moment';
import { Component, Input, Output, EventEmitter, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/angular-formio-pdf/angular-formio-pdf.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var moment = momentImported;
var AngularFormioPdfComponent = /** @class */ (function () {
    function AngularFormioPdfComponent() {
        this.onRenderBase64 = new EventEmitter();
        this.onRenderBuffer = new EventEmitter();
        this.onRenderBlob = new EventEmitter();
        this.pdfconfig = {
            footer: (/**
             * @param {?} currentPage
             * @param {?} pageCount
             * @return {?}
             */
            function (currentPage, pageCount) {
                return [{ text: currentPage.toString() + ' of ' + pageCount, alignment: 'right', margin: [0, 40, 20, 15] }];
            }),
            pageSize: 'A4',
            pageOrientation: 'portrait',
            pageMargins: [40, 40, 40, 80],
            content: [],
            styles: {
                header: {
                    fontSize: 18,
                    bold: true,
                    margin: [0, 0, 0, 15],
                    alignment: 'center'
                },
                label: {
                    bold: true,
                    fontSize: 14,
                    lineHeight: 1.3
                },
                value: {
                    height: 30,
                    color: '#222'
                },
                table: {
                    margin: [0, 5, 0, 15]
                },
                tableHeader: {
                    bold: true,
                    fontSize: 13,
                    color: 'black',
                    alignment: 'center',
                    margin: [0, 5, 0, 5]
                },
                para: {
                    lineHeight: 1.5,
                    alignment: 'center',
                    margin: [0, 10, 0, 15]
                },
                columns: {
                    margin: [0, 15, 0, 15]
                },
                signature: {
                    width: 520
                }
            },
            defaultStyle: {
                columnGap: 20
            }
        };
    }
    /**
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.pdf = __assign({}, this.pdfconfig, this.pdf);
        this.simplifiedDate = this.component.map((/**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            return _this.getSimplifiedLayout(v);
        }));
        this.simplifiedDate.map((/**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            _this.getSimplifiedPdfLayout(v);
        }));
        this.generatepdf();
    };
    /**
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.generatepdf = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var pdfDocGenerator = pdfMake.createPdf(this.pdfconfig);
        pdfDocGenerator.getDataUrl((/**
         * @param {?} dataUrl
         * @return {?}
         */
        function (dataUrl) {
            /** @type {?} */
            var targetElement = document.getElementById('angularFormIOPdf');
            /** @type {?} */
            var iframe = _this.createiframe();
            iframe.src = dataUrl;
            targetElement.appendChild(iframe);
        }));
        pdfDocGenerator.getBase64((/**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            // alert(data);
            _this.onRenderBase64.emit(data);
        }));
        pdfDocGenerator.getBuffer((/**
         * @param {?} buffer
         * @return {?}
         */
        function (buffer) {
            _this.onRenderBuffer.emit(buffer);
        }));
        pdfDocGenerator.getBlob((/**
         * @param {?} blob
         * @return {?}
         */
        function (blob) {
            _this.onRenderBlob.emit(blob);
        }));
    };
    /**
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.createiframe = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var iframe = document.createElement('iframe');
        iframe.setAttribute('id', 'ifAssessmentView');
        iframe.setAttribute('name', 'ifAssessmentView');
        iframe.setAttribute('frameborder', '0');
        iframe.setAttribute('webkitallowfullscreen', '');
        iframe.setAttribute('mozallowfullscreen', '');
        iframe.setAttribute('allowfullscreen', '');
        iframe.setAttribute('style', 'width: -webkit-fill-available; height: -webkit-fill-available;');
        return iframe;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.getSimplifiedLayout = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        var _this = this;
        if (data.type === 'columns') {
            return this.getLayoutColumns(data);
        }
        else if (data.type === 'fieldset' || data.type === 'panel' || data.type === 'well') {
            if (data.type === 'panel') {
                return {
                    type: data.type,
                    value: this.submission[data.key] ? this.submission[data.key] : '',
                    key: data.key,
                    hidelabel: false,
                    label: data.title,
                    input: data.input,
                    component: this.getComponent(data.components)
                };
            }
            else {
                return {
                    type: data.type,
                    value: this.submission[data.key] ? this.submission[data.key] : '',
                    key: data.key,
                    hidelabel: data.hideLabel,
                    label: data.label,
                    input: data.input,
                    component: this.getComponent(data.components)
                };
            }
        }
        else if (data.type === 'table') {
            return {
                type: data.type,
                value: this.submission[data.key] ? this.submission[data.key] : '',
                key: data.key,
                hidelabel: data.hideLabel,
                label: data.label,
                input: data.input,
                component: data.rows.map((/**
                 * @param {?} k
                 * @return {?}
                 */
                function (k) {
                    return k.map((/**
                     * @param {?} c
                     * @return {?}
                     */
                    function (c) {
                        return _this.getComponent(c.components);
                    }));
                }))
            };
        }
        else if (data.input) {
            /** @type {?} */
            var out = {
                type: data.type,
                value: this.submission[data.key] ? this.submission[data.key] : '',
                key: data.key,
                hidelabel: data.hideLabel,
                label: data.label,
                input: data.input,
                component: data.components && data.components.length ? this.getComponent(data.components) : undefined
            };
            if (data.type === 'datetime') {
                out.value = this.submission[data.key] ? moment(this.submission[data.key]).format('DD-MM-YYYY') : '';
            }
            else if (data.key === 'submit') {
                out.value = '';
                out.hidelabel = true;
            }
            return out;
        }
    };
    /**
     * @param {?} v
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.getLayoutColumns = /**
     * @param {?} v
     * @return {?}
     */
    function (v) {
        var _this = this;
        /** @type {?} */
        var obj = {
            type: v.type,
            value: this.submission[v.key] ? this.submission[v.key] : '',
            key: v.key,
            label: v.label,
            component: v.columns.map((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                if (x.type === 'column') {
                    return {
                        type: x.type,
                        value: _this.submission[x.key] ? _this.submission[x.key] : '',
                        key: x.key,
                        hidelabel: x.hideLabel,
                        label: x.label,
                        input: false,
                        component: x.components && x.components.length ? _this.getComponent(x.components) : undefined
                    };
                }
                else {
                    return v.type;
                }
            }))
        };
        obj.component = [].concat.apply([], obj.component);
        return obj;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.getComponent = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        var _this = this;
        return data.map((/**
         * @param {?} k
         * @return {?}
         */
        function (k) {
            if (k.input && k.type !== 'button' && k.key !== 'submit') {
                if (k.type === 'signature' && _this.submission[k.key] !== '') {
                    return {
                        type: k.type,
                        value: _this.submission[k.key] ? _this.submission[k.key] : '',
                        key: k.key,
                        image: true,
                        hidelabel: true,
                        label: k.label,
                        input: k.input,
                        component: k.components && k.components.length ? _this.getComponent(k.components) : undefined
                    };
                }
                else {
                    /** @type {?} */
                    var out = {
                        type: k.type,
                        value: _this.submission[k.key] ? _this.submission[k.key] : '',
                        key: k.key,
                        image: false,
                        hidelabel: k.hideLabel,
                        label: k.label,
                        input: k.input,
                        component: k.components && k.components.length ? _this.getComponent(k.components) : undefined
                    };
                    if (k.type === 'checkbox' || k.type === 'radio') {
                        out.hidelabel = true;
                    }
                    if (k.type === 'datetime') {
                        out.value = _this.submission[k.key] ? moment(_this.submission[k.key]).format('DD-MM-YYYY') : '';
                    }
                    return out;
                }
            }
            else if (k.type === 'htmlelement') {
                if (k.content.includes('<img src=')) {
                    return {
                        type: k.type,
                        value: k.content.replaceAll('<img src="', '').replaceAll('" alt="">', '').replaceAll('<br>', ''),
                        key: k.key,
                        hidelabel: true,
                        image: true,
                        label: k.label,
                        input: k.input,
                        component: k.components && k.components.length ? _this.getComponent(k.components) : undefined
                    };
                }
                else {
                    return {
                        type: k.type,
                        value: k.content.replaceAll('<center>', '').replaceAll('</center>', '').replaceAll('<input>', '').replaceAll('</input>', '')
                            .replaceAll('<b>', '').replaceAll('</b>', '').replaceAll('<p>', '').replaceAll('</p>', '')
                            .replaceAll('<br>', ''),
                        key: k.key,
                        image: false,
                        hidelabel: true,
                        label: k.label,
                        style: k.style,
                        margin: k.margin,
                        input: k.input,
                        component: k.components && k.components.length ? _this.getComponent(k.components) : undefined
                    };
                }
            }
            else {
                return !k.input ? _this.getSimplifiedLayout(k) : k.type;
            }
        }));
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.getSimplifiedPdfLayout = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        var _this = this;
        if (data.type === 'columns') {
            if (data.component && data.component.length) {
                this.pdfconfig.content.push(this.getPdfLayoutColumns(data.component));
            }
        }
        else if (data.type === 'fieldset' || data.type === 'panel' || data.type === 'well') {
            if (data.type === 'panel') {
                if (!data.hidelabel) {
                    this.pdfconfig.content.push({
                        text: data.label,
                        style: 'header'
                    });
                }
                if (data.component && data.component.length) {
                    /** @type {?} */
                    var component = this.getPdfComponent(data.component, 'panel');
                    component = [].concat.apply([], component);
                    this.pdfconfig.content.push(component);
                }
            }
            else {
                this.getPdfInput(data);
            }
        }
        else if (data.type === 'table') {
            /** @type {?} */
            var tabel = {
                style: 'table',
                table: {
                    widths: data.component[0].map((/**
                     * @param {?} x
                     * @return {?}
                     */
                    function (x) { return '*'; })),
                    body: data.component.map((/**
                     * @param {?} k
                     * @param {?} ind
                     * @return {?}
                     */
                    function (k, ind) {
                        /** @type {?} */
                        var rows = k.map((/**
                         * @param {?} c
                         * @return {?}
                         */
                        function (c) {
                            /** @type {?} */
                            var columns;
                            if (ind === 0) {
                                columns = c.length ? _this.getPdfComponent(c, 'table', true) : '';
                            }
                            else {
                                columns = c.length ? _this.getPdfComponent(c, 'table') : '';
                            }
                            columns = typeof columns !== 'string' ? [].concat.apply([], columns) : '';
                            return columns;
                        }));
                        return rows;
                    }))
                }
            };
            this.pdfconfig.content.push(tabel);
        }
        else if (data.input) {
            this.pdfconfig.content.push(this.getPdfInput(data));
        }
    };
    /**
     * @param {?} v
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.getPdfLayoutColumns = /**
     * @param {?} v
     * @return {?}
     */
    function (v) {
        var _this = this;
        /** @type {?} */
        var col = v.map((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            /** @type {?} */
            var component = x.component ? _this.getPdfComponent(x.component, 'column') : '';
            component = typeof component !== 'string' ? [].concat.apply([], component) : '';
            return component;
        }));
        /** @type {?} */
        var updatedcol = col.map((/**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            return {
                text: v === '' ? [] : v
            };
        }));
        updatedcol = [].concat.apply([], updatedcol);
        return {
            columns: updatedcol,
            style: 'columns'
        };
    };
    /**
     * @param {?} data
     * @param {?=} type
     * @param {?=} tablehead
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.getPdfComponent = /**
     * @param {?} data
     * @param {?=} type
     * @param {?=} tablehead
     * @return {?}
     */
    function (data, type, tablehead) {
        var _this = this;
        return data.map((/**
         * @param {?} k
         * @return {?}
         */
        function (k) {
            if (k.input) {
                /** @type {?} */
                var arr = [];
                if (!k.hidelabel) {
                    arr.push({
                        text: k.label + " \n",
                        style: 'label'
                    });
                }
                if (k.image && k.value !== '') {
                    arr.push({
                        image: k.value,
                        style: 'signature'
                    });
                }
                else {
                    arr.push({
                        text: "" + k.value,
                        style: 'value'
                    });
                }
                if (k.component && k.component.length) {
                    arr.push(_this.getPdfComponent(k.component, 'inner'));
                }
                if (type === 'inner' || type === 'table' || type === 'column') {
                    return arr;
                }
                else {
                    _this.pdfconfig.content.push(arr);
                }
            }
            else if (k.type === 'htmlelement') {
                /** @type {?} */
                var arr = [];
                if (k.image && k.value !== '') {
                    arr.push({
                        image: k.value
                    });
                }
                else {
                    if (tablehead) {
                        arr.push({
                            text: k.value,
                            style: 'tableHeader'
                        });
                    }
                    else {
                        /** @type {?} */
                        var styles = k.style ? k.style : {};
                        /** @type {?} */
                        var textWithStyles = __assign({ text: k.value, style: 'para' }, styles);
                        arr.push(textWithStyles);
                    }
                }
                if (k.component && k.component.length) {
                    arr.push(_this.getPdfComponent(k.component, 'inner'));
                }
                if (type === 'table') {
                    return arr;
                }
                else {
                    _this.pdfconfig.content = __spread(_this.pdfconfig.content, arr);
                }
            }
            else {
                if (!k.input) {
                    _this.getSimplifiedPdfLayout(k);
                }
            }
        }));
    };
    /**
     * @param {?} v
     * @return {?}
     */
    AngularFormioPdfComponent.prototype.getPdfInput = /**
     * @param {?} v
     * @return {?}
     */
    function (v) {
        if (!v.hidelabel) {
            this.pdfconfig.content.push({
                text: v.label + " \n",
                style: 'label'
            });
        }
        this.pdfconfig.content.push({
            text: "" + v.value,
            style: 'value'
        });
        if (v.component && v.component.length) {
            /** @type {?} */
            var arr = [];
            arr.push(this.getPdfComponent(v.component));
            arr = [].concat.apply([], arr);
            this.pdfconfig.content.push(arr);
        }
    };
    AngularFormioPdfComponent.decorators = [
        { type: Component, args: [{
                    selector: 'angular-formio-pdf',
                    template: "<div id=\"angularFormIOPdf\"></div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    AngularFormioPdfComponent.ctorParameters = function () { return []; };
    AngularFormioPdfComponent.propDecorators = {
        component: [{ type: Input }],
        submission: [{ type: Input }],
        pdf: [{ type: Input }],
        onRenderBase64: [{ type: Output }],
        onRenderBuffer: [{ type: Output }],
        onRenderBlob: [{ type: Output }]
    };
    return AngularFormioPdfComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/angular-formio-pdf.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularFormioPdfModule = /** @class */ (function () {
    function AngularFormioPdfModule() {
    }
    AngularFormioPdfModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [AngularFormioPdfComponent],
                    imports: [],
                    exports: [AngularFormioPdfComponent]
                },] }
    ];
    return AngularFormioPdfModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: angular-formio-pdf.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AngularFormioPdfComponent, AngularFormioPdfModule };

//# sourceMappingURL=angular-formio-pdf.js.map